% Demonstration of the SOLVEINX package.

% A simple example

solve({x=a,y=b,x-y=0},{x,y});

% The old behaviour

off solveinconsistent;

solve({x=a,y=b,x-y=0},{x,y});

on solveinconsistent;

% The consistency conditions might not be solvable

solve({x=2,x=3},{x});

% A bigger example

solve({4x+y=1,3x+y=-a,10x+2y=a**3},{x,y});

% Check if 3.4.1 workaround for 1 variable functions

solve({x=c,x=b,x=a},{x});

% Inconsistent system of linear equations.

solve({2*x1+3*x2-x3-2,7*x1+4*x2+2*x3-8,3*x1-2*x2+4*x3-5},
      {x1,x2,x3});

if inconsistent!* then write "Inconsistency!!!";

end;
